/*
**  CREATYPE.SQL
**
**  Create the user defined data types.
**
**  IMPORTANT: This script requires an empty database.  It is not 
**  "reexecutable" once anything other than user defined datatypes
**  have been added to the database.  
**
**  Don't forget to say 'USE Credit' first.
**
*/


PRINT 'Begin CREATYPE.SQL'
GO


USE Credit
SET NOCOUNT ON
GO
IF ( (SELECT db_name()) <> 'Credit')
BEGIN
   RAISERROR ('Database "Credit" not found.',22,127) WITH LOG
END
GO


IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'numeric_id' )
    EXEC  sp_droptype  numeric_id

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'corp_no' )
    EXEC  sp_droptype  corp_no

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'provider_no' )
    EXEC  sp_droptype  provider_no

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'category_no' )
    EXEC  sp_droptype  category_no

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'statecode' )
    EXEC  sp_droptype  statecode

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'countrycode' )
    EXEC  sp_droptype  countrycode

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'mailcode' )
    EXEC  sp_droptype  mailcode

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'phonenumber' )
    EXEC  sp_droptype  phonenumber

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'status_code' )
    EXEC  sp_droptype  status_code

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'yes_no' )
    EXEC  sp_droptype  yes_no

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'letter' )
    EXEC  sp_droptype  letter

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'shortstring' )
    EXEC  sp_droptype  shortstring

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'normstring' )
    EXEC  sp_droptype  normstring

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'longstring' )
    EXEC  sp_droptype  longstring

IF EXISTS ( SELECT name FROM systypes
            WHERE usertype >= 100 AND name = 'remarks' )  
    EXEC  sp_droptype  remarks
GO

  
EXEC  sp_addtype  numeric_id,  'int'
EXEC  sp_addtype  statecode,   'char(2)'
EXEC  sp_addtype  countrycode, 'char(2)'
EXEC  sp_addtype  mailcode,    'char(10)'
EXEC  sp_addtype  phonenumber, 'char(13)'
EXEC  sp_addtype  status_code, 'char(2)'
EXEC  sp_addtype  yes_no,      'char(1)'
EXEC  sp_addtype  letter,      'char(1)'
EXEC  sp_addtype  shortstring, 'varchar(15)'
EXEC  sp_addtype  normstring,  'varchar(31)'
EXEC  sp_addtype  longstring,  'varchar(63)'
EXEC  sp_addtype  remarks,     'varchar(255)'
GO

-- Did it work?

SELECT name AS 'TYPE'
FROM systypes
WHERE usertype >= 100
ORDER BY usertype
SELECT ' ' = ' '
GO
